/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   ms_ext.c                                           :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: tmaze <tmaze@student.42.fr>                +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2019/10/25 18:21:47 by tmaze             #+#    #+#             */
/*   Updated: 2019/11/18 09:35:44 by tmaze            ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#include "minishell.h"

void	*return_null(char *msg)
{
	ft_printf("%s\n", msg);
	return (NULL);
}

t_env	*search_key(t_env *env, char *cmd, int index)
{
	t_env	*it;
	t_env	*ret;
	int		i;
	int		j;

	it = env;
	ret = NULL;
	while (it && cmd[index + 1])
	{
		i = 0;
		j = index;
		while (it->key[i] && cmd[j] && it->key[i] == cmd[j])
		{
			i++;
			j++;
		}
		if (!it->key[i] && (!ret || ft_strlen(it->key) > ft_strlen(ret->key)))
		{
			ft_printf("found key: %s\n", it->key);
			ret = it;
		}
		it = it->next;
	}
	return (ret);
}

char	*replace_env(char *src, t_env *elem, int key_size, int i)
{
	char	*ret;
	int		res_len;

	res_len = ft_strlen(src) - key_size + ft_strlen(elem->val);
	if ((ret = ft_strnew(res_len)) != NULL)
	{
		ft_strncpy(ret, src, i);
		ft_strcat(ret, elem->val);
		ft_strcat(ret, src + 1 + key_size);
	}
	else
		ft_printf("minishell: memory error\n");
	return (ret);
}

char	*resolve_complete_key(char *src, int *index, t_env *env)
{
	t_env	*tmp;
	char	*ret;
	
	if ((tmp = search_key(env, src, *index + 1)) != NULL)
	{
		if ((ret = replace_env(src, tmp, ft_strlen(tmp->key)
							   + 1, *index)) != NULL)
		{
			ft_strdel(&src);
			src = ret;
			*index += ft_strlen(tmp->val);
			return (src);
		}
		else
			return return_null("minishell: memory error");
	}
	else
		return return_null("minishell: variable not found");
}

char	**res_ext(char **av, t_env *env)
{
	int		i[3];
	t_env	*tmp;
	char	*ret;

	i[0] = 0;
	while (av && av[i[0]])
	{
		i[2] = 0;
		while (av[i[0]] && av[i[0]][i[2]])
		{
			if (av[i[0]][i[2]] == '~'	&& (tmp = ft_envgetelem("HOME", env))
				!= NULL	&& (ret = replace_env(av[i[0]], tmp, 1, i[2])) != NULL)
			{
				ft_strdel(&av[i[0]]);
				av[i[0]] = ret;
				i[2] += ft_strlen(tmp->val);
			}
			else if (av[i[0]][i[2]] == '$'
					&& resolve_complete_key(av[i[0]], &i[2], env) == NULL)
				return (NULL);
			i[2]++;
		}
		i[0]++;
	}
	return (av);
}
